diff --git a/examples/widgets/itemviews/dirview/main.cpp b/examples/widgets/itemviews/dirview/main.cpp
index eefea657f6..79d384a043 100644
--- a/examples/widgets/itemviews/dirview/main.cpp
+++ b/examples/widgets/itemviews/dirview/main.cpp
@@ -77,6 +77,7 @@ int main(int argc, char *argv[])
     if (parser.isSet(dontUseCustomDirectoryIconsOption))
         model.iconProvider()->setOptions(QFileIconProvider::DontUseCustomDirectoryIcons);
     QTreeView tree;
+    tree.setDragDropMode(QTreeView::DragOnly);
     tree.setModel(&model);
     if (!rootPath.isEmpty()) {
         const QModelIndex rootIndex = model.index(QDir::cleanPath(rootPath));
diff --git a/src/gui/kernel/qshortcutmap.cpp b/src/gui/kernel/qshortcutmap.cpp
index 6c19eab287..e2d5240e66 100644
--- a/src/gui/kernel/qshortcutmap.cpp
+++ b/src/gui/kernel/qshortcutmap.cpp
@@ -53,7 +53,7 @@
 QT_BEGIN_NAMESPACE
 
 // To enable verbose output uncomment below
-//#define DEBUG_QSHORTCUTMAP
+#define DEBUG_QSHORTCUTMAP
 
 /* \internal
     Entry data for QShortcutMap
@@ -408,12 +408,15 @@ QKeySequence::SequenceMatch QShortcutMap::nextState(QKeyEvent *e)
 bool QShortcutMap::hasShortcutForKeySequence(const QKeySequence &seq) const
 {
     Q_D(const QShortcutMap);
+    qDebug() << __FUNCTION__ << seq <<d->sequences.size();
     QShortcutEntry entry(seq); // needed for searching
     const auto itEnd = d->sequences.cend();
     auto it = std::lower_bound(d->sequences.cbegin(), itEnd, entry);
 
     for (;it != itEnd; ++it) {
-        if (matches(entry.keyseq, (*it).keyseq) == QKeySequence::ExactMatch && (*it).correctContext() && (*it).enabled) {
+        bool m = matches(entry.keyseq, (*it).keyseq) == QKeySequence::ExactMatch && (*it).correctContext() && (*it).enabled;
+        qDebug() << __FUNCTION__ << "matching " << seq << (*it).keyseq << m;
+        if (m) {
             return true;
         }
     }
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 34519cd91b..dc6568ae5a 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -390,6 +390,7 @@ bool QWindowSystemInterface::handleShortcutEvent(QWindow *window, ulong timestam
 
 QT_DEFINE_QPA_EVENT_HANDLER(bool, handleKeyEvent, QWindow *window, QEvent::Type t, int k, Qt::KeyboardModifiers mods, const QString & text, bool autorep, ushort count) {
     unsigned long time = QWindowSystemInterfacePrivate::eventTime.elapsed();
+qDebug() << __FUNCTION__ <<     window << t <<  k <<  mods <<  text <<  autorep <<  count;
     return handleKeyEvent<Delivery>(window, time, t, k, mods, text, autorep, count);
 }
 
@@ -412,6 +413,10 @@ bool QWindowSystemInterface::handleExtendedKeyEvent(QWindow *window, QEvent::Typ
                                                     ushort count, bool tryShortcutOverride)
 {
     unsigned long time = QWindowSystemInterfacePrivate::eventTime.elapsed();
+    qDebug() << __FUNCTION__ << window << type << "key=0x" << hex << key << dec << "mods=" << modifiers
+             <<  text <<  autorep <<  count
+             << "tryShortcutOverride="<< tryShortcutOverride;
+
     return handleExtendedKeyEvent(window, time, type, key, modifiers, nativeScanCode, nativeVirtualKey, nativeModifiers,
                            text, autorep, count, tryShortcutOverride);
 }
diff --git a/src/plugins/platforms/windows/qwindowscontext.cpp b/src/plugins/platforms/windows/qwindowscontext.cpp
index 9ab131808b..cca77269ee 100644
--- a/src/plugins/platforms/windows/qwindowscontext.cpp
+++ b/src/plugins/platforms/windows/qwindowscontext.cpp
@@ -64,6 +64,7 @@
 #include <qpa/qwindowsysteminterface.h>
 #include <qpa/qplatformnativeinterface.h>
 #include <QtGui/QGuiApplication>
+#include <private/qwindowsguieventdispatcher_p.h>
 
 #include <QtCore/QSet>
 #include <QtCore/QHash>
@@ -1013,12 +1014,18 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
     case QtWindows::KeyEvent:
     case QtWindows::InputMethodKeyEvent:
     case QtWindows::InputMethodKeyDownEvent:
-    case QtWindows::AppCommandEvent:
+    case QtWindows::AppCommandEvent: {
+        qDebug() << '\n' << __FUNCTION__ << msg.hwnd << hex << "msg=0x" << msg.message
+                 << QWindowsGuiEventDispatcher::windowsMessageName(msg.message)
+                 << msg.lParam << msg.wParam;
 #if QT_CONFIG(sessionmanager)
-        return platformSessionManager()->isInteractionBlocked() ? true : d->m_keyMapper.translateKeyEvent(platformWindow->window(), hwnd, msg, result);
+        bool r = platformSessionManager()->isInteractionBlocked() ? true : d->m_keyMapper.translateKeyEvent(platformWindow->window(), hwnd, msg, result);
+        qDebug() << __FUNCTION__ << "returns" << r << '\n';
+        return r;
 #else
         return d->m_keyMapper.translateKeyEvent(platformWindow->window(), hwnd, msg, result);
 #endif
+    }
     case QtWindows::MoveEvent:
         platformWindow->handleMoved();
         return true;
diff --git a/src/plugins/platforms/windows/qwindowskeymapper.cpp b/src/plugins/platforms/windows/qwindowskeymapper.cpp
index 3987d8ca29..54236deb67 100644
--- a/src/plugins/platforms/windows/qwindowskeymapper.cpp
+++ b/src/plugins/platforms/windows/qwindowskeymapper.cpp
@@ -806,6 +806,7 @@ static inline void sendExtendedPressRelease(QWindow *w, int k,
 bool QWindowsKeyMapper::translateKeyEvent(QWindow *widget, HWND hwnd,
                                           const MSG &msg, LRESULT *result)
 {
+    qDebug() << __FUNCTION__ << widget << msg;
     *result = 0;
 
     // Reset layout map when system keyboard layout is changed
@@ -835,10 +836,13 @@ bool QWindowsKeyMapper::translateKeyEvent(QWindow *widget, HWND hwnd,
 
 bool QWindowsKeyMapper::translateMultimediaKeyEventInternal(QWindow *window, const MSG &msg)
 {
+    qDebug() << __FUNCTION__ << window << msg;
 #if defined(WM_APPCOMMAND)
     // QTBUG-57198, do not send mouse-synthesized commands as key events in addition
-    if (GET_DEVICE_LPARAM(msg.lParam) == FAPPCOMMAND_MOUSE)
+    if (GET_DEVICE_LPARAM(msg.lParam) == FAPPCOMMAND_MOUSE) {
+        qDebug() << __FUNCTION__ << "bail out FAPPCOMMAND_MOUSE";
         return false;
+    }
     const int cmd = GET_APPCOMMAND_LPARAM(msg.lParam);
     const int dwKeys = GET_KEYSTATE_LPARAM(msg.lParam);
     int state = 0;
@@ -847,15 +851,19 @@ bool QWindowsKeyMapper::translateMultimediaKeyEventInternal(QWindow *window, con
 
     QWindow *receiver = m_keyGrabber ? m_keyGrabber : window;
 
-    if (cmd < 0 || cmd > 52)
+    if (cmd < 0 || cmd > 52) {
+        qDebug() << __FUNCTION__ << "bail out 0..52";
         return false;
+    }
 
     const int qtKey = int(CmdTbl[cmd]);
     sendExtendedPressRelease(receiver, qtKey, Qt::KeyboardModifier(state), 0, 0, 0);
     // QTBUG-43343: Make sure to return false if Qt does not handle the key, otherwise,
     // the keys are not passed to the active media player.
     const QKeySequence sequence(Qt::Modifier(state) + qtKey);
-    return QGuiApplicationPrivate::instance()->shortcutMap.hasShortcutForKeySequence(sequence);
+    bool r=  QGuiApplicationPrivate::instance()->shortcutMap.hasShortcutForKeySequence(sequence);
+    qDebug() << __FUNCTION__ << "hasShortcutForKeySequence=" << r;
+    return r;
 #else
     Q_UNREACHABLE();
     return false;